'
' =============================================================================
' QFileAssociation           April 2004                              by Jacques
'
'             Association of an Executable to a File Extension
'                 with Possibility to restore the Old one
' Component                                                  Version 0.1.0 beta
' march 2006  V0.1.0  replaced "\\" by  Chr$(92)  (bugged with $Escapechar Off)
'             and some \"  by CHr$(34)                                        "
' =============================================================================
'        *****  WITH NO WARRANTY. USE AT YOUR OWN RISK. I USE IT  *****
' =============================================================================
Const SFA_HKEY_CLASSES_ROOT = &H80000000
' ---- SFA ERRORS LIST
Const SFA_SET_RESTORABLE_ALL_OK = 1
Const SFA_SIMPLE_SET_ALL_OK = 2
Const SFA_RESTORE_ALL_OK = 4
Const SFA_SHOW_RELATED_VALUE_ALL_OK = 8
'
Const SFA_ERROR_INVALID_OPENTYPE_OPEN_SET = 16
Const SFA_ERROR_NO_EXTENSION_DESCRIPTOR_DEFINED = 32
Const SFA_ERROR_BACK_UP_OLD_ALREADY_EXISTS = 64
Const SFA_ERROR_EXTENSION_NOT_YET_DEFINED_CANT_SAVE_OLD_DESCRIPTOR = 128
'
Const SFA_ERROR_FILE_ASSOCIATION_BUSY = 256
Const SFA_ERROR_EXTENSION_IS_AN_NULLTRING = 512
'
Const SFA_ERROR_RESTORE_NEW_AND_OR_OLD_DESCRIPTOR_MISSING_CANT_RESTORE = 1024
Const SFA_ERROR_RESTORE_EXTENSION_KEY_DONT_EXIST = 2048
Const SFA_ERROR_RESTORE_FA_KEY_MISSING_CANT_RESTORE = 4096
'
Const SFA_SHOW_RELATED_VALUE_EXTENSION_DONT_EXIST = 8192
Const SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS = 16384
' ---- END OF SFA ERROR LIST
' =============================================================================
Type QFileAssociation Extends QObject
    Private:
        Busy As Long
        regFA As QRegistry
'        BU_Prefix As String   ' set it 'once for all' : uncomment this line
    Public:
        NewDefaultDescriptorValue As String
        DefaultIcon As String
        OpenType As String
        Open As String
        BU_Prefix As String    ' set it 'once for all' : comment this line
    Constructor
        Busy = 0
        DefaultIcon = ""
        OpenType = "Open"
        Open = ""
        BU_Prefix = "YOUR_MARK"       ' Set here you Registry Back up mark ; IE  "JDOE"
        NewDefaultDescriptorValue = ""
        regFA.RootKey = SFA_HKEY_CLASSES_ROOT
    End Constructor
  With QFileAssociation
' -----------------------------------------------------------------------------
  Private:
    Sub ResetProperties
        .Busy = 0
        .DefaultIcon = ""
        .OpenType = "Open"
        .Open = ""
        .NewDefaultDescriptorValue = ""
        .regFA.RootKey = SFA_HKEY_CLASSES_ROOT
    End Sub
' -----------------------------------------------------------------------------
    Function RenameKey (sOldName As String, sNewName As String, iDeleteOld As Long) As Long
        DefInt iValCount, iKeyCount, iSubKeyCount, iIndex, N, P
        DefStr sValueName, sValueData, sKeyRead, sKeyWrite
        If (.regFA.KeyExists (sOldName) = 0 and sOldName <> "" And sNewName <> "") Then
            Result = 0
            Exit Function
        End If
        Dim slKey_2 As QStringList
        slKey_2.Clear
        .regFA.CreateKey (sNewName)
        .regFA.OpenKey (sOldName, 0)
            iValCount = .regFA.ValueItemCount - 1
            iKeyCount = .regFA.KeyItemCount - 1
        .regFA.CloseKey
'       VALUES
        For N = 0 To iValCount
            .regFA.OpenKey (sOldName, 0)
                sValueName = .regFA.ValueItem(N)
                sValueData = .regFA.ReadString (sValueName)
            .regFA.CloseKey
            .regFA.OpenKey (sNewName, 0)
                If sValueData <> "" Then .regFA.WriteString (sValueName, sValueData)
            .regFA.CloseKey
        Next N
'       READ SUB KEYS AND SAVE THEM IN slKey_2
        For N = 0 To iKeyCount
            .regFA.OpenKey (sOldName, 0)
                slKey_2.AddItems (sOldName & Chr$(92) & .regFA.KeyItem(N))
            .regFA.CloseKey
        Next N
'
        iIndex = 0
        While iIndex < slKey_2.ItemCount
            sKeyRead = slKey_2.Item(iIndex)
            .regFA.OpenKey(sKeyRead, 0)
                iSubKeyCount = .regFA.KeyItemCount - 1
                For P = 0 to iSubKeyCount
                    slKey_2.InsertItem (iIndex + P + 1, sKeyRead & Chr$(92) & .regFA.KeyItem(P))
                Next P
                iValCount = .regFA.ValueItemCount - 1
            .regFA.closeKey
'
            sKeyWrite = sNewName & Mid$(sKeyRead, Instr(sKeyRead, Chr$(92)))
            .regFA.CreateKey (sKeyWrite)
            For N = 0 To iValCount
                .regFA.OpenKey (sKeyRead, 0)
                    sValueName = .regFA.ValueItem(N)
                    sValueData = .regFA.ReadString (sValueName)
                .regFA.CloseKey
                .regFA.OpenKey (sKeyWrite, 0)
                    If sValueData <> "" Then .regFA.WriteString (sValueName, sValueData)
                .regFA.CloseKey
            Next N
            Inc iIndex
        Wend
        If iDeleteOld = 1 Then .regFA.DeleteKey (sOldName)
        Result = 1
    End Function
' -----------------------------------------------------------------------------
  Public:
    Function SetFileAssociation (sFileExtension As string, sCommand As String) As long
        DefStr sDescriptor, sFileExt
        If .Busy = 1 Then
            Result = SFA_ERROR_FILE_ASSOCIATION_BUSY
            GOTO ENDOFSET
        End If
        .Busy = 1
        ' Check If File Extension is not Empty
        If sFileExtension = "" Then
            Result = SFA_ERROR_EXTENSION_IS_AN_NULLTRING
            GOTO ENDOFSET
        End If
        ' Check that there is a DOT most left ".Bas" and not "Bas", if missing, I add it.
        If Left$(sFileExtension, 1) <> "." Then
            sFileExt = "." & sFileExtension
        Else
            sFileExt = sFileEXtension
        End If
        ' Maximum four characters plus the dot "."
        If Len(sFileExt) > 5 Then
            Result = SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS
            GOTO ENDOFSET
        End If
        sDescriptor = (sFileExt - ".") & "_File"
        If .regFA.KeyExists (sDescriptor) Then
            .regFA.DeleteKey (sDescriptor)
            DoEvents
        End If
        .regFA.OpenKey (sFileExt, 1)
            .regFA.WriteString ("", sDescriptor)
        .regFA.CloseKey
        .regFA.OpenKey(sDescriptor & Chr$(92) & "Shell" & Chr$(92) & "Open" & Chr$(92) & "Command", 1)
            .regFA.WriteString ("", sCommand)
        .regFA.CloseKey
ENDOFSET:
        .ResetProperties
        .Busy = 0
    End Function
' -----------------------------------------------------------------------------
    Function SetFileAssociationAndSaveOld (sFileExtension As String, sCommand as String) As Long
        DefStr sBU_OldDescrValue, sBU_NewDescrValue, sFileExt
        DefStr sNewDescrValue
        DefStr sBU_OldDescrName = .BU_Prefix & "_OLD"      ' IE : "YOUR_MARK" & "_OLD"   ' Old Descriptor Back Up, to UNDO
        DefStr sBU_NewDescrName = .BU_Prefix & "_NEW"      ' IE : "YOUR_MARK" & "_NEW"
        If .Busy = 1 Then
            Result = SFA_ERROR_FILE_ASSOCIATION_BUSY
            Goto ENDOFSETRESTORE
        End If
        .Busy = 1
        ' Check If File Extension is not Empty
        If sFileExtension = "" Then
            Result = SFA_ERROR_EXTENSION_IS_AN_NULLTRING
            Goto ENDOFSETRESTORE
        End If
        ' Check that there is a DOT most left ".Bas" and not "Bas", if missing, I add it.
        If Left$(sFileExtension, 1) <> "." Then
            sFileExt = "." & sFileExtension
        Else
            sFileExt = sFileEXtension
        End If
        ' Set sNewDescr if sFileDescriptor = ""
        If .NewDefaultDescriptorValue <> "" Then
            sNewDescrValue = .NewDefaultDescriptorValue
        Else
            sNewDescrValue = (sFileExt - ".") & "_File"     ' Default Name Set to  IE : "Bas_File"
        End If
        ' Maximum four characters plus the dot "."
        If Len(sFileExt) > 5 Then
            Result = SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS
            GOTO ENDOFSETRESTORE
        End If
        sBU_NewDescrValue = sNewDescrValue
        Result = SFA_SET_RESTORABLE_ALL_OK                  ' Reset the Error Flag
        If .regFA.KeyExists(sFileExt) Then                        ' Key IE ".Bas" already exists
            ' Get Extension 'Old' Descriptor Name : IE  "BAS_File" for ".Bas"
            .regFA.OpenKey (sFileExt, 0)
                sBU_OldDescrValue = .regFA.ReadString ("")
            .regFA.CloseKey
            If (.NewDefaultDescriptorValue <> "" And .regFA.KeyExists(sBU_OldDescrValue)) Then   ' If "" no Store/restore
                ' Rename Old Extension Descriptor to save It
                .regFA.OpenKey (sFileExt, 0)
                If .regFA.ValueExists ("") = 1 Then                               ' If a default Descriptor already defined
                    If .regFA.ValueExists(sBU_OldDescrName) = 0 Then              ' If _OLD dont defined Yet
                        .regFA.RenameValue ("", sBU_OldDescrName)
                        .regFA.WriteString (sBU_OldDescrName, sBU_OldDescrValue & "_Save")
                        .regFA.WriteString ("", sNewDescrValue)                   ' Set the new default FA descriptor
                        .regFA.WriteString (sBU_NewDescrName, sBU_NewDescrValue)  ' Used by restore to delete this new FA
                        .regFA.CloseKey
                        ' MoveKey Sets not defined ValueData to Empty string ... may cause problems ???
                        ' .regFA.MoveKey (sBU_OldDescrValue, sBU_OldDescrValue & "_Save", 0) ' Rename "Bas_File" >> "Bas_File_Save" and Delete "Bas_File"
                        .RenameKey(sBU_OldDescrValue, sBU_OldDescrValue & "_Save", 1) ' Rename "Bas_File" >> "Bas_File_Save" and Delete "Bas_File"
                    Else
                    ' If YOUR_MARK_OLD Already Exists
                        Result = Result or SFA_ERROR_BACK_UP_OLD_ALREADY_EXISTS
                        .regFA.CloseKey
                    End If
                Else                                                ' If NO default Descriptor defined
                    Result = Result or SFA_ERROR_NO_EXTENSION_DESCRIPTOR_DEFINED
                    .regFA.CloseKey
                End If
            Else
                .regFA.OpenKey (sFileExt, 0)
                    .regFA.WriteString ("", sNewDescrValue)
                .regFA.CloseKey
            End If
        Else
            ' Create Extension Descriptor   IE  "BAS_File" for ".Bas"
            .regFA.OpenKey (sFileExt, 1)
                    .regFA.WriteString ("", sNewDescrValue)
            .regFA.CloseKey
            Result = Result or SFA_ERROR_EXTENSION_NOT_YET_DEFINED_CANT_SAVE_OLD_DESCRIPTOR
        End If
        ' Creates New Key Name Pointed by NewDescriptor if dont exist and Give it default Value (not necessary)
        If .regFA.KeyExists (sNewDescrValue) = 0 Then ' Create Key
            .regFA.OpenKey (sNewDescrValue, 1)
                If sNewDescrValue <> "" Then .regFA.WriteString ("", sNewDescrValue)
            .regFA.CloseKey
        Else              ' Dont Create Key
            .regFA.OpenKey (sNewDescrValue, 0)
                If sNewDescrValue <> "" Then .regFA.WriteString ("", sNewDescrValue)
            .regFA.CloseKey
        End If
        ' Create DefaultIcon = defines an Default Icon linked to that extension
        If .DefaultIcon <> "" Then
            .regFA.OpenKey (sNewDescrValue & Chr$(92) & "DefaultIcon", 1)
                .regFA.WriteString ("", .DefaultIcon)
            .regFA.CloseKey
        End If
        ' Create Shell = define how to 'Shell' that extension. Can be "Open", "Print", "Explore"
        ' see API ShellExecute Doc
        .regFA.OpenKey (sNewDescrValue &  Chr$(92) & "Shell", 1)
            Select Case LCase$(.OpenType)
                Case ""
                    .regFA.WriteString ("", "Open")       ' "Open" if OpenType = ""
                Case "open", "print", "explore"
                    .regFA.WriteString ("", .OpenType)
                Case Else
                    .regFA.WriteString ("", "Open")
                    Result = Result & SFA_ERROR_INVALID_OPENTYPE_OPEN_SET
            End select
        .regFA.CloseKey
        ' Create Open = ????  ... parent key for Command :)
        .regFA.OpenKey (sNewDescrValue &  Chr$(92) & "Shell" & Chr$(92) & "Open", 1)
            If .Open <> "" Then .regFA.WriteString ("", .Open)     ' let it with no value
        .regFA.CloseKey
        ' Create Command = the Path\application to run for that Extension
        .regFA.OpenKey (sNewDescrValue &  Chr$(92) & "Shell" & Chr$(92) & "Open" & Chr$(92) & "Command", 1)
            .regFA.WriteString ("", sCommand)
        .regFA.CloseKey
ENDOFSETRESTORE:
        .ResetProperties
        .Busy = 0
    End function
' -----------------------------------------------------------------------------
    Function RestoreOldFA (sFileExtension As String) As Long
        DefStr sFileExt, sOldDescrName, sNewDescrName, sTmp, sNewDescrValue, sOldDescrValue, sDefaultValue
        sOldDescrName = .BU_Prefix & "_OLD"
        sNewDescrName = .BU_Prefix & "_NEW"
        Result = SFA_RESTORE_ALL_OK
        If .Busy = 1 Then
            Result = SFA_ERROR_FILE_ASSOCIATION_BUSY
            Goto ENDOFRESTORE
        End If
        .Busy = 1
        ' Check If File Extension is not Empty
        If sFileExtension = "" Then
            Result = SFA_ERROR_EXTENSION_IS_AN_NULLTRING
            Goto ENDOFRESTORE
        End If
        If Left$(sFileExtension, 1) <> "." Then
            sFileExt = "." & sFileExtension
        Else
            sFileExt = sFileExtension
        End If
        ' Maximum four characters plus the dot "."
        If Len(sFileExt) > 5 Then
            Result = SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS
            GOTO ENDOFRESTORE
        End If
        If .regFA.KeyExists(sFileExt) <> 0 Then
            .regFA.OpenKey (sFileExt, 0)
                If (.regFA.ValueExists (sOldDescrName) <> 0 and .regFA.ValueExists(sNewDescrName) <> 0) Then
                    sNewDescrValue = .regFA.ReadString (sNewDescrName)
                    sOldDescrValue = .regFA.ReadString (sOldDescrName)        ' Read Old Descriptor to restore
                    .regFA.WriteString("", sOldDescrValue - "_Save")          ' Set Old Descriptor value as Default Value
                    .regFA.DeleteValue (sOldDescrName)                        ' Delete OldDescriptor
                    .regFA.DeleteValue (sNewDescrName)
                    .regFA.CloseKey
                    If (.regFA.KeyExists (sOldDescrValue) And .regFA.KeyExists(sNewDescrValue)) Then
                        If .regFA.KeyExists (sOldDescrValue - "_Save") Then .regFA.DeleteKey (sOldDescrValue - "_Save")
                        DoEvents    ' .RenameKey refuses to overwrite, wait key deleted
                        ' .regFA.MoveKey (sOldDescrValue, sOldDescrValue - "_Save", 1) ' restore Rename sOldDescrValue
                        .RenameKey (sOldDescrValue, sOldDescrValue - "_Save", 1) ' restore Rename sOldDescrValue
                        .regFA.DeleteKey (sNewDescrValue)                            ' Delete NewValue
                    Else
                        Result = Result Or SFA_ERROR_RESTORE_FA_KEY_MISSING_CANT_RESTORE
                    End If
                Else
                    Result = Result Or SFA_ERROR_RESTORE_NEW_AND_OR_OLD_DESCRIPTOR_MISSING_CANT_RESTORE
                    .regFA.CloseKey
                    Goto ENDOFRESTORE
                End If
        Else
            Result = Result Or SFA_ERROR_RESTORE_EXTENSION_KEY_DONT_EXIST
        End If
ENDOFRESTORE:
        .ResetProperties
        .Busy = 0
    End Function
' -----------------------------------------------------------------------------
    Function GetFileAssociationErrorAsString (iError As Long) As String
        Result = ""
        If iError = SFA_SHOW_RELATED_VALUE_ALL_OK Then Result = "      *** SFA_SHOW_RELATED_VALUE_ALL_OK":Exit Function
        If iError = SFA_SET_RESTORABLE_ALL_OK Then Result = "      *** SFA_SET_RESTORABLE_ALL_OK":Exit Function
        If iError = SFA_SIMPLE_SET_ALL_OK Then Result = "      *** SFA_SIMPLE_SET_ALL_OK":Exit Function
        If iError = SFA_RESTORE_ALL_OK Then Result = "      *** SFA_RESTORE_ALL_OK":Exit Function
        If (iError And SFA_ERROR_BACK_UP_OLD_ALREADY_EXISTS) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_BACK_UP_OLD_ALREADY_EXISTS"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_BACK_UP_OLD_ALREADY_EXISTS"
            End If
        End If
        If  (iError And SFA_ERROR_NO_EXTENSION_DESCRIPTOR_DEFINED) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_NO_EXTENSION_DESCRIPTOR_DEFINED"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_NO_EXTENSION_DESCRIPTOR_DEFINED"
            End If
        End If
        If (iError And SFA_ERROR_EXTENSION_NOT_YET_DEFINED_CANT_SAVE_OLD_DESCRIPTOR) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_EXTENSION_NOT_YET_DEFINED_CANT_SAVE_OLD_DESCRIPTOR"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_EXTENSION_NOT_YET_DEFINED_CANT_SAVE_OLD_DESCRIPTOR"
            End If
        End IF
        If (iError And SFA_ERROR_INVALID_OPENTYPE_OPEN_SET) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_INVALID_OPENTYPE_OPEN_SET"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_INVALID_OPENTYPE_OPEN_SET"
            End If
        End If
        If (iError And SFA_ERROR_RESTORE_NEW_AND_OR_OLD_DESCRIPTOR_MISSING_CANT_RESTORE) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_RESTORE_NEW_AND_OR_OLD_DESCRIPTOR_MISSING_CANT_RESTORE"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_RESTORE_NEW_AND_OR_OLD_DESCRIPTOR_MISSING_CANT_RESTORE"
            End If
        End If
        If (iError And SFA_ERROR_RESTORE_EXTENSION_KEY_DONT_EXIST) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_RESTORE_EXTENSION_KEY_DONT_EXIST"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_RESTORE_EXTENSION_KEY_DONT_EXIST"
            End If
        End If
        If (iError And SFA_ERROR_RESTORE_FA_KEY_MISSING_CANT_RESTORE) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_RESTORE_FA_KEY_MISSING_CANT_RESTORE"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_RESTORE_FA_KEY_MISSING_CANT_RESTORE"
            End If
        End If
        If (iError And SFA_ERROR_FILE_ASSOCIATION_BUSY) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_FILE_ASSOCIATION_BUSY"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_FILE_ASSOCIATION_BUSY"
            End If
        End If
        If (iError And SFA_ERROR_EXTENSION_IS_AN_NULLTRING) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_EXTENSION_IS_AN_NULLTRING"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_EXTENSION_IS_AN_NULLTRING"
            End If
        End If
        If (iError And SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS) <> 0 Then
            If Result = "" Then
                Result = "      *** SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS"
            Else
                Result = Result & Chr$(10) & "  and *** SFA_ERROR_EXTENSION_MORE_THAN_FOUR_CHARACTERS"
            End If
        End If
    End Function
  End With
' -----------------------------------------------------------------------------
    Function ShowRelatedKeysAndValues (sFileExt As String) As String
        DefInt N, P, iValCount, iSubKeyCount, iIndex, iDegree
        DefStr sValueName, sValueData, sTmp, sTmp1, sKey, sHeader, sResult = ""
        Dim regFA1 As QRegistry
        Dim slKey As QStringList
        slKey.Clear
        sResult = ""
      With regFA1
        .RootKey = SFA_HKEY_CLASSES_ROOT
        If .KeyExists (sFileExt) = 0 Then
            Result = Chr$(10) & "key " & Chr$(34) & sFileExt & Chr$(34) & " Dont Exist"
            Exit Function
        Else
            sResult = Chr$(10) & "key : " & Chr$(34) & sFileExt & Chr$(34)
        End If
        .OpenKey (sFileEXt, 0)
            iValCount = .ValueItemCount - 1
            For N = 0 To iValCount
                sValueName = .ValueItem(N)
                sValueData = .ReadString (sValueName)
                sTmp = Space$ (25)
                sTmp = Replace$(sTmp,"      value : " & Chr$(34) & sValueName & Chr$(34), 1)
                sTmp1 = Space$ (100)
                sTmp1 = Replace$ (sTmp1, " = " & Chr$(34) & sValueData & Chr$(34), 1)
                sResult = sResult & Chr$(10) & sTmp & Rtrim$(sTmp1)
                slKey.AddItems (sValueData)
            Next N
        .CloseKey
        iIndex = 0
        While iIndex < slKey.ItemCount
            sKey = slKey.Item(iIndex)
            If .KeyExists (sKey) Then
                sResult = sResult & Chr$(10) & "key : " & Chr$(34) & sKey & Chr$(34)
                .OpenKey(sKey, 0)
                    iSubKeyCount = .KeyItemCount - 1
                    For P = 0 to iSubKeyCount
                        slKey.InsertItem (iIndex + P + 1, sKey & Chr$(92) & .KeyItem(P))
                    Next P
                    iValCount = .ValueItemCount - 1
                    For N = 0 To iValCount
                        sValueName = .ValueItem(N)
                        sValueData = .ReadString (sValueName)
                        sTmp = Space$ (25)
                        sTmp = Replace$(sTmp,"      value : " & Chr$(34) & sValueName & Chr$(34), 1)
                        sTmp1 = Space$ (25)
                        sTmp1 = Replace$ (sTmp1, " = " & Chr$(34) & sValueData & Chr$(34), 1)
                        sResult = sResult & Chr$(10) & sTmp & Rtrim$(sTmp1)
                    Next N
                .closeKey
            End If
            Inc iIndex
        Wend
      End With
        Result = sResult
    End Sub
End type
'
' =============================================================================
'
